/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ContainerAnalysisNoteIamBindingConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#id ContainerAnalysisNoteIamBinding#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#members ContainerAnalysisNoteIamBinding#members}
    */
    readonly members: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#note ContainerAnalysisNoteIamBinding#note}
    */
    readonly note: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#project ContainerAnalysisNoteIamBinding#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#role ContainerAnalysisNoteIamBinding#role}
    */
    readonly role: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#condition ContainerAnalysisNoteIamBinding#condition}
    */
    readonly condition?: ContainerAnalysisNoteIamBindingCondition;
}
export interface ContainerAnalysisNoteIamBindingCondition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#description ContainerAnalysisNoteIamBinding#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#expression ContainerAnalysisNoteIamBinding#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding#title ContainerAnalysisNoteIamBinding#title}
    */
    readonly title: string;
}
export declare function containerAnalysisNoteIamBindingConditionToTerraform(struct?: ContainerAnalysisNoteIamBindingConditionOutputReference | ContainerAnalysisNoteIamBindingCondition): any;
export declare class ContainerAnalysisNoteIamBindingConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ContainerAnalysisNoteIamBindingCondition | undefined;
    set internalValue(value: ContainerAnalysisNoteIamBindingCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding google_container_analysis_note_iam_binding}
*/
export declare class ContainerAnalysisNoteIamBinding extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_container_analysis_note_iam_binding";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/4.78.0/docs/resources/container_analysis_note_iam_binding google_container_analysis_note_iam_binding} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ContainerAnalysisNoteIamBindingConfig
    */
    constructor(scope: Construct, id: string, config: ContainerAnalysisNoteIamBindingConfig);
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _members?;
    get members(): string[];
    set members(value: string[]);
    get membersInput(): string[] | undefined;
    private _note?;
    get note(): string;
    set note(value: string);
    get noteInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _condition;
    get condition(): ContainerAnalysisNoteIamBindingConditionOutputReference;
    putCondition(value: ContainerAnalysisNoteIamBindingCondition): void;
    resetCondition(): void;
    get conditionInput(): ContainerAnalysisNoteIamBindingCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
